## ld.so-1.9.9.tar.gz

=== Makefile ===
include Version.mk
include Config.mk

SUBDIRS = man util d-link
ifeq ($(AOUT_SUPPORT),true)
SUBDIRS += ld-so
endif
ifeq ($(ARCH),i386)
SUBDIRS += test
endif

all:
	set -e ; for d in $(SUBDIRS) ; do $(MAKE) -C $$d ; done

install: all
	sh instldso.sh

clean:
	set -e ; for d in $(SUBDIRS) ; do $(MAKE) -C $$d $@ ; done
	-find . -name '*~' | xargs rm -f

dist:
	$(MAKE) clean
	$(MAKE) all
	find . -name '*.o' | xargs rm
	cd .. && \
	tar cvf ld.so-$(VERSION).tar ld.so-$(VERSION) && \
	gzip -v9 ld.so-$(VERSION).tar

=== d-link/Makefile ===
include ../Version.mk
include ../Config.mk

CC = $(LIBC5_CC)

DIRS = $(ARCH) libdl

CFLAGS += -I. -I./$(ARCH) -DNO_UNDERSCORE -DVERBOSE_DLINKER \
	-DUSE_CACHE -fPIC -D__PIC__ #-funroll-loops

SRC2S = boot1.c hash.c readelflib1.c vsprintf.c

SRCS	= $(SRC1S) $(SRC2S)
OBJ1S	= $(SRC1S:.S=.o)
OBJ2S	= $(SRC2S:.c=.o)
OBJS	= $(OBJ1S) $(OBJ2S)

DLINKER = ld-linux.so

ELF_LDFLAGS=--shared # using GNU ld
#ELF_LDFLAGS=-G  # with SVr4 ld

lib:: $(OBJS)
	@for i in $(DIRS); do \
	  echo making $@ in $$i; \
	  ($(MAKE) -C $$i $@); \
	done;
	$(LD) -e _dl_boot $(ELF_LDFLAGS) -o $(DLINKER) \
	  -soname $(DLINKER).$(VMAJOR) *.o

obj: $(OBJS)

realclean::
	$(RM) -f .depend $(DLINKER) core *.o *.a *.s *.i tmp_make foo *~

clean::
	$(RM) -f $(DLINKER) core *.o *.a *.s *.i tmp_make foo *~

depend::
	$(CC) $(CFLAGS) -M $(SRCS) | \
		sed -e 's,^[ 	]*\(.*.o\)[ 	]*:,$(STATIC_DIR)/$(SUBDIR)/\1 $(SHARED_DIR)/$(SUBDIR)/\1 $(SHARED_LITE_DIR)/$(SUBDIR)/\1 $(DEBUG_DIR)/$(SUBDIR)/\1 $(PROFILE_DIR)/$(SUBDIR)/\1 $(CHECKER_DIR)/$(SUBDIR)/\1:,' > .depend
#	$(MAKE) subdir TARGET=depend

ifneq ($(DIRS),)
lib realclean clean depend::
	@for i in $(DIRS); do \
	  echo making $@ in $$i; \
	  ($(MAKE) -C $$i $@); \
	done;
endif

#
# include a dependency file if one exists
#
ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== man/Makefile ===
include ../Version.mk
include ../Config.mk

ALL = #ld.so.info

all:	$(ALL)

ld.so.info: ld.so.texi
	makeinfo $<

clean:
	rm -f $(ALL) *~

=== util/Makefile ===
include ../Version.mk
include ../Config.mk

ALL	= ldconfig ldd lddstub elf-ok

all:	$(ALL)

ldconfig: ldconfig.o readelf.o
	$(CC) -static $(CFLAGS) $(LDFLAGS) $^ -o $@

ldd:	ldd.o readelf.o
	$(CC) -static $(CFLAGS) $(LDFLAGS) $^ -o $@

ldd.o:	ldd.c
	$(CC) -c $(CFLAGS) -DLDSO_ADDR=$(LDSO_ENTRY) $< -o $@

ifeq ($(DEBUG),true)
STUBFLAGS = -Wl,-dynamic-linker,../d-link/ld-linux.so
endif

lddstub: lddstub.o
	$(LIBC5_CC) $(CFLAGS) $(LDFLAGS) $(STUBFLAGS) $^ -o $@

elf-ok: elf-ok.S
	$(CC) $(CFLAGS) -nostartfiles -static -s $^ -o $@

clean:
	rm -f $(ALL) *.o *~ core

=== d-link/libdl/Makefile ===
include ../../Version.mk
include ../../Config.mk

CC = $(LIBC5_CC)

CFLAGS += -I.. -I../$(ARCH) -DNO_UNDERSCORE -DVERBOSE_DLINKER -DUSE_CACHE
CFLAGS += -fPIC -D__PIC__ #-funroll-loops

SRC2S = dlib.c

SRCS	= $(SRC1S) $(SRC2S)
OBJ1S	= $(SRC1S:.S=.o)
OBJ2S	= $(SRC2S:.c=.o)
OBJS	= $(OBJ1S) $(OBJ2S)

LIBDL = libdl.so

ELF_LDFLAGS=--shared -nostartfiles -nostdlib # using GNU ld
#ELF_LDFLAGS=-G  # with SVr4 ld

lib:: $(OBJS)
	$(CC) $(ELF_LDFLAGS) -o $(LIBDL) -Wl,-soname -Wl,libdl.so.$(VMAJOR) *.o -lc

obj: $(OBJS)

realclean::
	$(RM) -f .depend $(LIBDL) core *.o *.a *.s *.i tmp_make foo *~

clean::
	$(RM) -f $(LIBDL) core *.o *.a *.s *.i tmp_make foo *~

depend::
	$(CC) $(CFLAGS) -M $(SRCS) | \
		sed -e 's,^[ 	]*\(.*.o\)[ 	]*:,$(STATIC_DIR)/$(SUBDIR)/\1 $(SHARED_DIR)/$(SUBDIR)/\1 $(SHARED_LITE_DIR)/$(SUBDIR)/\1 $(DEBUG_DIR)/$(SUBDIR)/\1 $(PROFILE_DIR)/$(SUBDIR)/\1 $(CHECKER_DIR)/$(SUBDIR)/\1:,' > .depend
#	$(MAKE) subdir TARGET=depend

ifneq ($(DIRS),)
lib realclean clean depend::
	@for i in $(DIRS); do \
	  echo making $@ in $$i; \
	  ($(MAKE) -C $$i $@); \
	done;
endif

#
# include a dependency file if one exists
#
ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== d-link/sparc/Makefile ===
include ../../Version.mk
include ../../Config.mk

CFLAGS += -I.. -I. -DNO_UNDERSCORE -DVERBOSE_DLINKER
CFLAGS += -fPIC -D__PIC__ #-DDEBUG # -funroll-loops

../%.o: %.S
	$(CC) $(CFLAGS) -D__ASSEMBLY__ -c $< -o $@
../%.o: %.c
	$(CC) $(CFLAGS) -c $< -o $@

# udiv.S umul.S  
# 
SRC1S = resolve.S  urem.S udiv.S
SRC2S = elfinterp.c

SRCS	= $(SRC1S) $(SRC2S)
OBJ1S	= $(SRC1S:.S=.o)
OBJ2S	= $(SRC2S:.c=.o)
OBJS	= $(OBJ1S) $(OBJ2S)

DLINK_OBJS:= $(addprefix ../, $(OBJS))

lib:: $(DLINK_OBJS)

obj: $(DLINK_OBJS)

asm: $(ASMS)

realclean::
	$(RM) -f .depend core *.o *.a *.s *.i tmp_make *~

clean::
	$(RM) -f core *.o *.a *.s *.i tmp_make *~

depend::
	$(CC) $(CFLAGS) -M $(SRCS) | \
		sed -e 's,^[ 	]*\(.*\.o\)[ 	]*:,../\1:,' > .depend
#	$(MAKE) subdir TARGET=depend

#
# include a dependency file if one exists
#
ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== ld-so/example/Makefile ===
include ../../Version.mk
include ../../Config.mk

ALL = foo bar.o dispinfo-bar.o readline-bar.o

all:	$(ALL)

foo:	foo.c $(LOBJS)
	$(AOUTCC) -o $@ $^

dispinfo.o: dispinfo.c
	$(AOUTCC) -c $^

bar.o:	bar.c
	$(AOUTCC) -c $^ -o a.out
	$(AOUTLD) -x -Ttext 0x50000000 -o $@ a.out -lc \
		-defsym preload_gethostname=__PLT____gethostname \
		-defsym preload_gethostid=__PLT__gethostid
	rm -f a.out

dispinfo-bar.o:	bar.c dispinfo.o
	$(AOUTCC) -c bar.c -o a.out
	$(AOUTLD) -x -Ttext 0x50000000 -o $@ a.out dispinfo.o -lc \
		-defsym preload_gethostname=__PLT____gethostname \
		-defsym preload_gethostid=__PLT__gethostid
	rm -f a.out

readline-bar.o:	bar.c
	@echo "****** This preload object may fail to build if you do not"
	@echo "******         have the readline library installed."
	@echo "****** Don't worry, just check out the other two examples."
	@echo
	$(AOUTCC) -c $^ -o a.out
	$(AOUTLD) -x -Ttext 0x50000000 -o $@ a.out dispinfo.o -lreadline -lc \
		-u __PLT__ding \
		-defsym preload_ding=__PLT__ding
	rm -f a.out

clean:
	rm -f $(ALL) *.o *~ core a.out

=== debian/changelog ===
ld.so (1.9.9-1) frozen unstable; urgency=low

  * Changed ld-linux.so and libdl.so to match glibc by not
    allowing user preloads of system libraries into setu/gid
    binaries unless the library itself is setuid.
  * Fixed problems in ld-linux.so on the sparc architecture
    (Juan Cespedes).

 -- David Engel <david@sw.ods.com>  Thu, 21 May 1998 10:56:20 -0500

ld.so (1.9.8-1) frozen unstable; urgency=low

  * Changed ldconfig to allow the expected type for all
    libraries in a directory to be optionally specified
    (Mark Phillips).  See the ldconfig man page.
  * Changed ldconfig to use the same type names used in the
    change above when the -p option is used.

 -- David Engel <david@sw.ods.com>  Sun, 26 Apr 1998 13:50:28 -0500

ld.so (1.9.7-1) unstable; urgency=low

  * Changed ldd for m68k to use /lib/ld.so.1 instead of 
    /lib/ld-linux.so.2.
  * Added support for dladdr to libdl.so (Eduard Gode).
  * Fixed a small memory leak in libdl.so (Richard Garnish).
  * Fixed a bug in ldconfig when the -l option was used on a
    filename without a '/' in it.
  * Updated the man pages (Bug#6404, Bug#9721, Bug#10652, 
    Bug#13494 and Bug#14127).  They could still use some work.
  * No longer install the info page since it's way out of date.
  * Fixed minor Debian packaging problems (Bug#13160, 
    Bug#15577 and Bug#19345).

 -- David Engel <david@sw.ods.com>  Sat, 14 Mar 1998 22:08:21 -0600

ld.so (1.9.6-2) unstable; urgency=low

  * Changed ld-linux.so to be compilable with gcc 2.8.0 (Sven 
    Verdoolaege)

 -- David Engel <david@sw.ods.com>  Thu, 11 Sep 1997 13:40:37 -0500

ld.so (1.9.6-1) unstable; urgency=low

  * Changed ldd to not use the glibc dynamic linker when run
    on a libc5-based shared library.
  * Added a -q option to ldconfig which causes warnings not
    to be printed (Bob Tinsley).
  * Dropped support for the Debian libdl1-dev package.

 -- David Engel <david@sw.ods.com>  Wed, 10 Sep 1997 14:40:15 -0500

ld.so (1.9.5-1) unstable; urgency=low

  * Fixed a bug in ldd where ld-linux.so.2 was not called
    correctly when run on shared libraries.
  * Fixed a problem in the previous version where some
    Makefiles were not architecture independent.

 -- David Engel <david@sw.ods.com>  Tue,  5 Aug 1997 20:13:22 -0500

ld.so (1.9.4-1) unstable; urgency=high

  * Fixed a bug in ld.so introduced in the previous version
    which broke preloads.
  * Turned a.out support back on by default, at least for the
    time being.  There are no promises to keep it.

 -- David Engel <david@sw.ods.com>  Sat, 26 Jul 1997 14:21:23 -0500

ld.so (1.9.3-1) unstable; urgency=high

  * Fixed buffer overflow bugs in ld-linux.so and ld.so.
  * Changed the README file a little to clarify a couple of
    things.
  * Changed ldconfig to chroot to the specified directory when
    the new -r option is used (Bob Tinsley).

 -- David Engel <david@sw.ods.com>  Mon, 21 Jul 1997 15:55:13 -0500

ld.so (1.9.2-3) unstable; urgency=low

  * Added a warning in the description not to downgrade to 
    version 1.8.x or earlier.
  * Changed /etc/ld.so.conf to not be a dpkg "conf" file 
    (Bug#9722).
  * Fixed a typo in debian/rules which affected m68k builds 
    (Bug#10025).

 -- David Engel <david@sw.ods.com>  Tue, 27 May 1997 10:27:48 -0500

ld.so (1.9.2-2) unstable; urgency=low

  * Added a libdl1-altdev package which can coexist with the
    libc6-dev package.

 -- David Engel <david@sw.ods.com>  Fri, 2 May 1997 21:45:40 -0500

ld.so (1.9.2-1) unstable; urgency=low

  * Removed /usr/local/lib from the default /etc/ld.so.conf
    for Debian (Bug#8181).
  * Changed ldconfig to be 64-bit clean (H.J. Lu).

 -- David Engel <david@sw.ods.com>  Tue, 22 Apr 1997 19:56:26 -0500

ld.so (1.9.1-1) unstable; urgency=low

  * Changed ldconfig to try to determine which libc a
    library is for even if it doesn't have an soname.
  * Fixed a bug in ldconfig where an older library using
    the glibc naming convention would be used instead of
    a newer library.
  * Changed to ld-linux.so and libdl.so to not require the 
    libc5 headers in order to compile.
  * Changed ldconfig and ldd to be compilable with either
    libc5 or libc6.

 -- David Engel <david@sw.ods.com>  Tue, 18 Mar 1997 20:46:50 -0600

ld.so (1.9.0-1) unstable; urgency=low

  * Changed to not build the old, a.out dynamic loader by
    default.
  * Changed instldso.sh to require the --force option to
    make sure users read the README file.
  * Changed instldso.sh to not install the libdl.so
    development files unless the --devfiles option is used.
  * Changed instldso.sh to not strip binaries and libraries
    if the --no-strip option is used.
  * Changed the Debian packaging to put the development files 
    which conflict with glibc in a new libdl1-dev package.
  * Changed ldd to use the glibc dynamic linker, if it is
    available, when run on a shared library.
  * Changed ld-linux.so to print the load addresses of
    libraries, ala glibc, when run by ldd.
  * Changed ld-linux.so to allow the libraries listed in 
    LD_PRELOAD to be separated by white space in addition to 
    colons.
  * Changed ld-linux.so to load the libraries listed in 
    LD_PRELOAD for setu/gid programs as long as they can be 
    loaded securely.
  * Changed ldconfig to update the symlinks for the dynamic
    linkers.
  * Changed ldconfig to try to determine if an ELF library is
    intended for libc5 or libc6 and save the infomation in the
    cache.  The mechanism used is rather simplistic and may
    need to be enhanced.
  * Changed ldconfig to print the type of ELF library when
    printing the cache.
  * Changed ld-linux.so to only load ELF shared libraries for
    use with libc5 or an unknown libc.

 -- David Engel <david@sw.ods.com>  Thu, 6 Mar 1997 20:25:22 -0600

ld.so (1.8.10-2) unstable; urgency=low

  * Changed the shlibs file so other packages would depend on ldso
    instead of libdl1.



=== debian/control ===
Source: ld.so
Section: base
Priority: required
Maintainer: David Engel <david@debian.org>
Standards-Version: 2.4.0.0

Package: ldso
Section: base
Priority: required
Essential: yes
Architecture: any
Provides: libdl1
Breaks: libc6 (<=2.0.1-1)
Description: The Linux dynamic linker, library and utilities.
 The dynamic linker provides the user-level support for loading and
 linking DLL and ELF shared libraries.  It is required by any program
 that uses shared libraries, which is just about all of them.
 .
 WARNING: Do NOT downgrade this package to version 1.8.x or earlier.
 Doing so may leave your system in an unusable state.

Package: libdl1-altdev
Section: devel
Priority: optional
Architecture: any
Depends: ldso (=${Source-Version}), libc5-altdev (>=5.4.0-0)
Description: The Linux dynamic linker library (alternative dev files).
 This package can be used to build libc5-based binaries even when 
 the libc6-dev package is installed.

=== debian/rules ===
#! /usr/bin/make -f
#
# Last updated: Thu Apr 26 22:00:00 CDT 1995 by david.
#
# To make the binary distribution package, the ``Debianized'' source package
# and the context diff to the original package, type `./debian.rules dist'.
# Make sure that `debian.rules' is executable before the final distribution
# is made.
#
# Invoke each target with `./debian.rules <target>'.  All targets should be
# invoked with the package root as the current directory.
#
# The `binary' target must be run as root, as it needs to install files with
# specific ownerships.  The `diff' target assumes that you have the original
# source package available, unpacked, in ../$(p)-$(v).orig, or that you have
# the previous revision of the ``Debianized'' source package and context diff
# in the parent directory.

include Version.mk
v = $(VERSION)
vm = $(VMAJOR)
arch = $(shell dpkg --print-architecture)
ifeq ($(arch),i386)
archx = i486
else
archx = $(arch)
endif

build:
# Builds the binary package.
	make ARCH=$(arch) clean
	make ARCH=$(arch)
	touch build

clean:
# Undoes the effect of `make -f debian.rules build'.
	make ARCH=$(arch) clean
	rm -f build
	rm -rf debian/tmp debian/files

binary-indep:   checkroot build
        $(checkdir)

binary-arch:    checkroot build
	$(checkdir)
	#
	##############################
	# build the ldso package
	rm -rf debian/tmp
	install -d -m 755 debian/tmp
	chmod g-s debian/tmp
	#
	install -d -m 755 debian/tmp/lib
	if [ -f ld-so/ld.so ]; then \
		install -s -m 755 ld-so/ld.so debian/tmp/lib/ld.so.$(v); \
	fi
	install -m 755 d-link/ld-linux.so debian/tmp/lib/ld-linux.so.$(v)
	strip -g -K _dl_debug_state debian/tmp/lib/ld-linux.so.$(v)
	ln -sf ld-linux.so.$(v) debian/tmp/lib/ld-linux.so.$(vm)
	install -s -m 755 d-link/libdl/libdl.so debian/tmp/lib/libdl.so.$(v)
	ln -sf libdl.so.$(v) debian/tmp/lib/libdl.so.$(vm)
	install -d -m 755 debian/tmp/sbin
	install -s -m 755 util/ldconfig debian/tmp/sbin/ldconfig.new
	#
	install -d -m 755 debian/tmp/usr/bin
	install -s -m 755 util/ldd debian/tmp/usr/bin/ldd
	install -d -m 755 debian/tmp/usr/lib
	install -s -m 755 util/lddstub debian/tmp/usr/lib/lddstub
	#
	install -d -m 755 debian/tmp/usr/man/man1
	install -m 644 man/ldd.1 debian/tmp/usr/man/man1/ldd.1
	install -d -m 755 debian/tmp/usr/man/man8
	install -m 644 man/ldconfig.8 debian/tmp/usr/man/man8/ldconfig.8
	install -m 644 man/ld.so.8 debian/tmp/usr/man/man8/ld.so.8
	gzip -9 debian/tmp/usr/man/man*/*
	#install -d -m 755 debian/tmp/usr/info
	#install -m 644 man/ld.so.info debian/tmp/usr/info
	#gzip -9 debian/tmp/usr/info/*
	#
	install -d -m 755 debian/tmp/usr/doc/ldso
	install -m 644 debian/copyright debian/tmp/usr/doc/ldso/copyright
	install -m 644 README debian/tmp/usr/doc/ldso/README
	gzip -9f debian/tmp/usr/doc/ldso/README
	install -m 644 debian/changelog debian/tmp/usr/doc/ldso/changelog
	gzip -9f debian/tmp/usr/doc/ldso/changelog
	#
	install -d -m 755 debian/tmp/DEBIAN
	install -m 644 debian/shlibs debian/tmp/DEBIAN/shlibs
	uuencode util/elf-ok elf-ok > /tmp/elf-ok.uue
	sed -e '/^__END__/r /tmp/elf-ok.uue' debian/preinst \
		> debian/tmp/DEBIAN/preinst
	chmod 755 debian/tmp/DEBIAN/preinst
	rm -f /tmp/elf-ok.uue
	sed -e 's/VERSION/$(v)/g' -e 's/VMAJOR/$(vm)/g' debian/postinst \
		> debian/tmp/DEBIAN/postinst
	chmod 755 debian/tmp/DEBIAN/postinst
	install -m 755 debian/prerm debian/tmp/DEBIAN/prerm
	#
	dpkg-gencontrol -pldso
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..
	#
	##############################
	# build the libdl1-altdev package
	rm -rf debian/tmp
	install -d -m 755 debian/tmp
	chmod g-s debian/tmp
	#
	install -d -m 755 debian/tmp/usr/$(archx)-linuxlibc1/lib
	ln -sf /lib/libdl.so.$(v) \
	  debian/tmp/usr/$(archx)-linuxlibc1/lib/libdl.so
	install -d -m 755 debian/tmp/usr/$(archx)-linuxlibc1/include
	install -m 644 d-link/libdl/dlfcn.h \
	  debian/tmp/usr/$(archx)-linuxlibc1/include/dlfcn.h
	#
	install -d -m 755 debian/tmp/usr/doc
	ln -sf ldso debian/tmp/usr/doc/libdl1-altdev
	#
	install -d -m 755 debian/tmp/DEBIAN
	dpkg-gencontrol -plibdl1-altdev
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..

binary: binary-indep binary-arch

checkroot:
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot
